<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">Tracking nr</label>
        <input type="text" id="track" class="form-value" v-model="parcel.trackingId"/>
      </div>
      <div class="err" id="track-err">
        <p style="color: red;">Tracking number should not be empty, should not contain
          special charachters, an should have 13-20 carachters;
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Due amount</label>
        <input type="text" id="due" class="form-value" v-model="parcel.dueAmount"/>
      </div>
      <div class="err" id="due-err">
        <p style="color: red;">due amount should be a number!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Weigth</label>
        <input type="text" id="weigth" class="form-value" v-model="parcel.weigth"/>
      </div>
      <div class="err" id="weigth-err">
        <p style="color: red;">wheigth should be a number!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Sent date</label>
        <input type="text" id="date" class="form-value" v-model="parcel.sentDate"/>
      </div>
      <div class="err" id="date-err">
        <p style="color: red;">date format should be YYYY-MM-DD</p>
      </div>
      <div class="form-content">
        <label class="form-label">Number of tries</label>
        <input type="number" id="nt" class="form-value" v-model="parcel.deliveryTry"/>
      </div>
      <div class="err" id="nt-err">
        <p style="color: red;">should be a number!</p>
      </div>
      <div class="form-content">
        <label class="form-label">Is_paid</label>
        <input type="checkbox" class="form-value" v-model="parcel.isPayed"/>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('Parcel')" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Parcels')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Parcel',
  props: {
    string: String,
  },
  data() {
    return {
      parcel: {},
    };
  },
  mounted() {
    this.get();
  },
  methods: {
    get() {
      if (this.string.length > 1) {
        axios.get(`http://localhost:4000/api/parcels/${this.string}`)
          .then((result) => {
            this.parcel = result.data;
          })
          .catch((e) => {
            console.log(e);
          });
      }
    },
    validateParcel(obj) {
      const reg = /[A-z]/;
      const reg3 = /(\d{4})-(\d{2})-(\d{2})/;
      const reg2 = /[A-Z]{2,5}\d.*[A-Z]{0,2}/;
      if (obj.trackingId && obj.weigth && obj.sentDate
        && (obj.dueAmount && !reg.test(obj.dueAmount))
        && (obj.deliveryTry && !reg.test(obj.deliveryTry))
        && !reg.test(obj.weigth) && reg2.test(obj.trackingId)
        && reg3.test(obj.sentDate)) {
        return true;
      }

      if (!obj.trackingId || !reg2.test(obj.trackingId)) {
        document.getElementById('track').style.borderColor = 'red';
        document.getElementById('track-err').style.display = 'block';
      }

      if (!obj.sentDate || !reg3.test(obj.sentDate)) {
        document.getElementById('date').style.border = 'red';
        document.getElementById('date-err').style.display = 'block';
      }

      if (obj.deliveryTry && reg.test(obj.deliveryTry)) {
        document.getElementById('nt').style.border = 'red';
        document.getElementById('nt-err').style.display = 'block';
      }

      if (obj.dueAmount && reg.test(obj.dueAmount)) {
        document.getElementById('due').style.border = 'red';
        document.getElementById('due-err').style.display = 'block';
      }

      if (obj.weigth || reg.test(obj.weigth)) {
        document.getElementById('weigth').style.border = 'red';
        document.getElementById('weight-err').style.display = 'block';
      }
      return false;
    },
    submit(component) {
      if (this.string.length === 1) {
        if (this.validateParcel(this.parcel)) {
          axios.post('http://localhost:4000/api/parcels', {
            trackingId: this.parcel.trackingId,
            dueAomunt: (this.parcel.dueAmount) ? this.parcel.dueAmount : 0.00,
            deliveryTry: (this.parcel.deliveryTry) ? this.parcel.deliveryTry : 0,
            sentDate: this.parcel.sentDate,
            weigth: this.parcel.weigth,
            isPayed: (this.parcel.isPayed) ? 1 : 0,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
          this.nullify();
          this.$emit('change-component', component);
        }
      } else if (this.validateParcel(this.parcel)) {
        axios.patch(`http://localhost:4000/api/parcels/${this.string}`, {
          trackingId: this.parcel.trackingId,
          dueAomunt: (this.parcel.dueAmount) ? this.parcel.dueAmount : 0.00,
          deliveryTry: (this.parcel.deliveryTry) ? this.parcel.deliveryTry : 0,
          sentDate: this.parcel.sentDate,
          weigth: this.parcel.weigth,
          isPayed: (this.parcel.isPayed) ? 1 : 0,
        })
          .then((response) => { console.log(response); alert('succesfully saved!'); })
          .catch((e) => {
            console.log(e);
          });

        this.$emit('change-component', component);
        this.$emit('string', 'a');
      }
    },
    nullify() {
      document.getElementById('track').value = '';
      document.getElementById('nt').value = '';
      document.getElementById('due').value = '';
      document.getElementById('weigth').value = '';
      document.getElementById('date').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
